// Addressdefinitions for H8S 2633
// Johann Gysin
// 02.07.2002

#ifndef _ioh82633_h
#define _ioh82633_h

// Allgemein
#define SYSCR   (*(volatile unsigned char*)(0xFFFFFDE5)) // System Control Register
#define MSTPCRA (*(volatile unsigned char*)(0xFFFFFDE8)) // Module Stop Control Register A (Fr TMR)
#define MSTPCRB (*(volatile unsigned char*)(0xFFFFFDE9)) // Module Stop Control Register B (Fr PWM und SCI)
#define MSTPCRC (*(volatile unsigned char*)(0xFFFFFDEA)) // Module Stop Control Register C (Fr SCI)

// Port 1
#define P1DDR   (*(volatile unsigned char*)(0xFFFFFE30)) // Port 1 Data Direction Register
#define P1DR    (*(volatile unsigned char*)(0xFFFFFF00)) // Port 1 Data Register
#define PORT1   (*(volatile unsigned char*)(0xFFFFFFB0)) // Port 1 Register

// Port 3
#define P3DDR   (*(volatile unsigned char*)(0xFFFFFE32)) // Port 3 Data Direction Register
#define P3DR    (*(volatile unsigned char*)(0xFFFFFF02)) // Port 3 Data Register
#define PORT3   (*(volatile unsigned char*)(0xFFFFFFB2)) // Port 3 Register
#define P3ODR   (*(volatile unsigned char*)(0xFFFFFE46)) // Port 3 Open-Drain Control Register

// Port 4
#define PORT4   (*(volatile unsigned char*)(0xFFFFFFB3)) // Port 4 Register

// Port 7
#define P7DDR   (*(volatile unsigned char*)(0xFFFFFE36)) // Port 7 Data Direction Register
#define P7DR    (*(volatile unsigned char*)(0xFFFFFF06)) // Port 7 Data Register
#define PORT7   (*(volatile unsigned char*)(0xFFFFFFB6)) // Port 7 Register

// Port A
#define PADDR   (*(volatile unsigned char*)(0xFFFFFE39)) // Port A Data Direction Register
#define PADR    (*(volatile unsigned char*)(0xFFFFFF09)) // Port A Data Register
#define PORTA   (*(volatile unsigned char*)(0xFFFFFFB9)) // Port A Register
#define PAPCR   (*(volatile unsigned char*)(0xFFFFFF40)) // Port A MOS Pull-Up Control Register
#define PAODR   (*(volatile unsigned char*)(0xFFFFFE47)) // Port A Open-Drain Control Register

// Port B
#define PBDDR   (*(volatile unsigned char*)(0xFFFFFE3A)) // Port B Data Direction Register
#define PBDR    (*(volatile unsigned char*)(0xFFFFFF0A)) // Port B Data Register
#define PORTB   (*(volatile unsigned char*)(0xFFFFFFBA)) // Port B Register
#define PBPCR   (*(volatile unsigned char*)(0xFFFFFF41)) // Port B MOS Pull-Up Control Register
#define PBODR   (*(volatile unsigned char*)(0xFFFFFE48)) // Port B Open-Drain Control Register

// Port C
#define PCDDR   (*(volatile unsigned char*)(0xFFFFFE3B)) // Port C Data Direction Register
#define PCDR    (*(volatile unsigned char*)(0xFFFFFF0B)) // Port C Data Register
#define PORTC   (*(volatile unsigned char*)(0xFFFFFFBB)) // Port C Register
#define PCPCR   (*(volatile unsigned char*)(0xFFFFFF42)) // Port C MOS Pull-Up Control Register
#define PCODR   (*(volatile unsigned char*)(0xFFFFFE49)) // Port C Open-Drain Control Register

// Port D
#define PDDDR   (*(volatile unsigned char*)(0xFFFFFE3C)) // Port D Data Direction Register
#define PDDR    (*(volatile unsigned char*)(0xFFFFFF0C)) // Port D Data Register
#define PORTD   (*(volatile unsigned char*)(0xFFFFFFBC)) // Port D Register
#define PDPCR   (*(volatile unsigned char*)(0xFFFFFE43)) // Port D MOS Pull-Up Control Register

// Port E
#define PEDDR   (*(volatile unsigned char*)(0xFFFFFE3D)) // Port E Data Direction Register
#define PEDR    (*(volatile unsigned char*)(0xFFFFFF0D)) // Port E Data Register
#define PORTE   (*(volatile unsigned char*)(0xFFFFFFBD)) // Port E Register
#define PEPCR   (*(volatile unsigned char*)(0xFFFFFE44)) // Port E MOS Pull-Up Control Register

// Port G
#define PGDDR   (*(volatile unsigned char*)(0xFFFFFE3F)) // Port G Data Direction Register
#define PGDR    (*(volatile unsigned char*)(0xFFFFFF0F)) // Port G Data Register
#define PORTG   (*(volatile unsigned char*)(0xFFFFFFBF)) // Port G Register

// PWM
#define DACR0   (*(volatile unsigned char*)(0xFFFFFDB8)) // PWM D/A Control Register 0 (Shared Register!)
#define DADRA0  (*(volatile unsigned int*)(0xFFFFFDB8))  // PWM D/A Data Register A0 (Shared Register!)
#define DADRB0  (*(volatile unsigned int*)(0xFFFFFDBA))  // PWM D/A Data Register B0 (Shared Register!)
#define DACNT0  (*(volatile unsigned int*)(0xFFFFFDBA))  // PWM D/A Counter 0 (Shared Register!)

#define DACR1   (*(volatile unsigned char*)(0xFFFFFDBC)) // PWM D/A Control Register 1 (Shared Register!)
#define DADRA1  (*(volatile unsigned int*)(0xFFFFFDBC))  // PWM D/A Data Register A1 (Shared Register!)
#define DADRB1  (*(volatile unsigned int*)(0xFFFFFDBE))  // PWM D/A Data Register B1 (Shared Register!)
#define DACNT1  (*(volatile unsigned int*)(0xFFFFFDBE))  // PWM D/A Counter 1 (Shared Register!)

// SCI
#define SCRX    (*(volatile unsigned char*)(0xFFFFFDB4)) // Serial Control Register X

#define SMR0    (*(volatile unsigned char*)(0xFFFFFF78)) // Serial Mode Register 0
#define BRR0    (*(volatile unsigned char*)(0xFFFFFF79)) // Bit Rate Register 0
#define SCR0    (*(volatile unsigned char*)(0xFFFFFF7A)) // Serial Control Register 0
#define TDR0    (*(volatile unsigned char*)(0xFFFFFF7B)) // Transmit Data Register 0
#define SSR0    (*(volatile unsigned char*)(0xFFFFFF7C)) // Serial Status Register 0
#define RDR0    (*(volatile unsigned char*)(0xFFFFFF7D)) // Receive Data Register 0
#define SCMR0   (*(volatile unsigned char*)(0xFFFFFF7E)) // Smart Card Mode Register 0
#define IrCR    (*(volatile unsigned char*)(0xFFFFFDB0)) // IrDA Control Register

#define SMR2    (*(volatile unsigned char*)(0xFFFFFF88)) // Serial Mode Register 2
#define BRR2    (*(volatile unsigned char*)(0xFFFFFF89)) // Bit Rate Register 2
#define SCR2    (*(volatile unsigned char*)(0xFFFFFF8A)) // Serial Control Register 2
#define TDR2    (*(volatile unsigned char*)(0xFFFFFF8B)) // Transmit Data Register 2
#define SSR2    (*(volatile unsigned char*)(0xFFFFFF8C)) // Serial Status Register 2
#define RDR2    (*(volatile unsigned char*)(0xFFFFFF8D)) // Receive Data Register 2
#define SCMR2   (*(volatile unsigned char*)(0xFFFFFF8E)) // Smart Card Mode Register 2

#define SMR3    (*(volatile unsigned char*)(0xFFFFFDD0)) // Serial Mode Register 3
#define BRR3    (*(volatile unsigned char*)(0xFFFFFDD1)) // Bit Rate Register 3
#define SCR3    (*(volatile unsigned char*)(0xFFFFFDD2)) // Serial Control Register 3
#define TDR3    (*(volatile unsigned char*)(0xFFFFFDD3)) // Transmit Data Register 3
#define SSR3    (*(volatile unsigned char*)(0xFFFFFDD4)) // Serial Status Register 3
#define RDR3    (*(volatile unsigned char*)(0xFFFFFDD5)) // Receive Data Register 3
#define SCMR3   (*(volatile unsigned char*)(0xFFFFFDD6)) // Smart Card Mode Register 3

// TMR
#define TCR0    (*(volatile unsigned char*)(0xFFFFFF68)) // Timer Control Register 0
#define TCSR0   (*(volatile unsigned char*)(0xFFFFFF6A)) // Timer Control/Status Register 0
#define TCORA0  (*(volatile unsigned char*)(0xFFFFFF6C)) // Timer Constant Register A0
#define TCORB0  (*(volatile unsigned char*)(0xFFFFFF6E)) // Timer Constant Register B0
#define TCNT0   (*(volatile unsigned char*)(0xFFFFFF70)) // Timer Counter 0

#define TCR1    (*(volatile unsigned char*)(0xFFFFFF69)) // Timer Control Register 1
#define TCSR1   (*(volatile unsigned char*)(0xFFFFFF6B)) // Timer Control/Status Register 1
#define TCORA1  (*(volatile unsigned char*)(0xFFFFFF6D)) // Timer Constant Register A1
#define TCORB1  (*(volatile unsigned char*)(0xFFFFFF6F)) // Timer Constant Register B1
#define TCNT1   (*(volatile unsigned char*)(0xFFFFFF71)) // Timer Counter 1

#define TCR2    (*(volatile unsigned char*)(0xFFFFFDC0)) // Timer Control Register 2
#define TCSR2   (*(volatile unsigned char*)(0xFFFFFDC2)) // Timer Control/Status Register 2
#define TCORA2  (*(volatile unsigned char*)(0xFFFFFDC4)) // Timer Constant Register A2
#define TCORB2  (*(volatile unsigned char*)(0xFFFFFDC6)) // Timer Constant Register B2
#define TCNT2   (*(volatile unsigned char*)(0xFFFFFDC8)) // Timer Counter 2

#define TCR3    (*(volatile unsigned char*)(0xFFFFFDC1)) // Timer Control Register 3
#define TCSR3   (*(volatile unsigned char*)(0xFFFFFDC3)) // Timer Control/Status Register 3
#define TCORA3  (*(volatile unsigned char*)(0xFFFFFDC5)) // Timer Constant Register A3
#define TCORB3  (*(volatile unsigned char*)(0xFFFFFDC7)) // Timer Constant Register B3
#define TCNT3   (*(volatile unsigned char*)(0xFFFFFDC9)) // Timer Counter 3

// Interrupt Controller Registers
#define ISCRH   (*(volatile unsigned char*)(0xFFFFFE12)) // IRQ Sense Control Register H
#define ISCRL   (*(volatile unsigned char*)(0xFFFFFE13)) // IRQ Sense Control Register L
#define IER     (*(volatile unsigned char*)(0xFFFFFE14)) // IRQ Enable Register
#define ISR     (*(volatile unsigned char*)(0xFFFFFE15)) // IRQ Status Register
#define IPRA    (*(volatile unsigned char*)(0xFFFFFEC0)) // Interrupt Priority Register A
#define IPRB    (*(volatile unsigned char*)(0xFFFFFEC1)) // Interrupt Priority Register B
#define IPRC    (*(volatile unsigned char*)(0xFFFFFEC2)) // Interrupt Priority Register C
#define IPRD    (*(volatile unsigned char*)(0xFFFFFEC3)) // Interrupt Priority Register D
#define IPRE    (*(volatile unsigned char*)(0xFFFFFEC4)) // Interrupt Priority Register E
#define IPRF    (*(volatile unsigned char*)(0xFFFFFEC5)) // Interrupt Priority Register F
#define IPRG    (*(volatile unsigned char*)(0xFFFFFEC6)) // Interrupt Priority Register G
#define IPRH    (*(volatile unsigned char*)(0xFFFFFEC7)) // Interrupt Priority Register H
#define IPRI    (*(volatile unsigned char*)(0xFFFFFEC8)) // Interrupt Priority Register I
#define IPRJ    (*(volatile unsigned char*)(0xFFFFFEC9)) // Interrupt Priority Register J
#define IPRK    (*(volatile unsigned char*)(0xFFFFFECA)) // Interrupt Priority Register K
#define IPRL    (*(volatile unsigned char*)(0xFFFFFECB)) // Interrupt Priority Register L
#define IPRO    (*(volatile unsigned char*)(0xFFFFFECE)) // Interrupt Priority Register O

#endif
