// SCI-Routines for serial interfaces
// Johann Gysin

#ifndef _SCI_H
#define _SCI_H

// SCI0
extern void SCI0_Init(void);                         // Initializes SCI0 with 19200 Baud, 8, N, 1
extern void SCI0_WriteChar(unsigned char Data);      // Sends a single character
extern void SCI0_WriteStr(const unsigned char *str); // Sends a string until the null-character is reached
extern void SCI0_WriteLn(const unsigned char *str);  // Like WriteStr but adds a CR (Carriage Return) and LF (Linefeed) hinzu
extern void SCI0_WriteCRLF(void);                    // Sends a CR (Carriage Return) and LF (Linefeed)
extern void SCI0_WriteInt(int zahl);                 // Converts a signed integer to a string and sends it
extern int SCI0_GetRecBufferCount(void);             // Gives back number of values in receive-buffer
extern int SCI0_GetSenBufferCount(void);             // Gives back number of values in send-buffer
extern char SCI0_GetRecBufferChar(void);             // Takes a character out of the receive-buffer
extern void SCI0_IRQRecChar(void);                   // IRQ-Function: Puts a received character in the receive-buffer
extern void SCI0_IRQSenChar(void);                   // IRQ-Function: Last character was sent
extern void SCI0_IRQError(void);                     // IRQ-Function: Error happened

// SCI2
extern void SCI2_Init(void);                         // Initializes SCI2 with 19200 Baud, 8, N, 1
extern void SCI2_WriteChar(unsigned char Data);      // Sends a single character
extern void SCI2_WriteStr(const unsigned char *str); // Sends a string until the null-character is reached
extern void SCI2_WriteLn(const unsigned char *str);  // Like WriteStr but adds a CR (Carriage Return) and LF (Linefeed) hinzu
extern void SCI2_WriteCRLF(void);                    // Sends a CR (Carriage Return) and LF (Linefeed)
extern void SCI2_WriteInt(int zahl);                 // Converts a signed integer to a string and sends it
extern int SCI2_GetRecBufferCount(void);             // Gives back number of values in send-buffer
extern int SCI2_GetSenBufferCount(void);             // Liefert Anzahl Zeichen im Sendebuffer
extern char SCI2_GetRecBufferChar(void);             // Takes a character out of the receive-buffer
extern void SCI2_IRQRecChar(void);                   // IRQ-Function: Puts a received character in the receive-buffer
extern void SCI2_IRQSenChar(void);                   // IRQ-Function: Last character was sent
extern void SCI2_Error(void);                        // IRQ-Function: Error happened

#endif
